﻿using SharpDX;
using System;
using System.Collections.Generic;
using VL.Core;

namespace VL.Dijkstra
{
    [Type]
    public class Vertex 
    {
        [Node]
        public Vector2 Position
        {
            get; private set;
        }

        [Node]
        public Dictionary<Vertex, double> Neighbours
        {
            get; private set;
        }

        [Node]
        public IEnumerable<int> GetNeighbourIndices()
        {
            foreach (var n in Neighbours.Keys) yield return n.Index;
        }

 /// <summary>
 /// MUST be unique in your graph
 /// </summary>
        [Node]
        public int Index
        {
            get; private set;
        }

        [Node]
        public Vertex(int index, Vector2 position)
        {
            this.Index = index;
            this.Position = position;
            Neighbours = new Dictionary<Vertex, double>();
        }

        [Node]
        public void AddNeighbour(Vertex neighbour, double weightedDistance)
        {
            Neighbours[neighbour] = weightedDistance;
        }

        //public override bool Equals(Object obj)
        //{
        //    return obj is Vertex && this == (Vertex)obj;
        //}
        //public override int GetHashCode()
        //{
        //    return Index.GetHashCode() ^ Position.GetHashCode();// ^ Neighbours.Count;
        //}

        //public bool Equals(Vertex other)
        //{
        //    return this == (Vertex)other;
        //}

        //[Node]
        //public static bool operator ==(Vertex x, Vertex y)
        //{
        //    // use only for class!!
        //    if (x == null || y == null) return false;
        //    //return x.Index == y.Index;
        //    return x.GetHashCode() == y.GetHashCode();
        //}

        //[Node]
        //public static bool operator !=(Vertex x, Vertex y)
        //{
        //    return !(x == y);
        //}
     
    }
}
